"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LazyGetter = void 0;
const lib_1 = require("./lib");
/** Save the getter's return value and don't call it again */
function LazyGetter(opts) {
    const { global = false, select } = opts ?? {};
    return function decorateLazyGetter(target, { name, static: isStatic, private: isPrivate }) {
        if (isStatic) {
            if (isPrivate) {
                return (0, lib_1.privateStatic)(target, select);
            }
        }
        else if (global) {
            return isPrivate
                ? (0, lib_1.privateStatic)(target, select)
                : (0, lib_1.publicInstanceGlobal)(name, target, select);
        }
        else if (isPrivate) {
            return (0, lib_1.privateInstance)(name, target, select);
        }
        return (0, lib_1.publicInstance)(name, target, select);
    };
}
exports.LazyGetter = LazyGetter;
