import { privateInstance, privateStatic, publicInstance, publicInstanceGlobal } from './lib';
/** Save the getter's return value and don't call it again */
function LazyGetter(opts) {
    const { global = false, select } = opts ?? {};
    return function decorateLazyGetter(target, { name, static: isStatic, private: isPrivate }) {
        if (isStatic) {
            if (isPrivate) {
                return privateStatic(target, select);
            }
        }
        else if (global) {
            return isPrivate
                ? privateStatic(target, select)
                : publicInstanceGlobal(name, target, select);
        }
        else if (isPrivate) {
            return privateInstance(name, target, select);
        }
        return publicInstance(name, target, select);
    };
}
export { LazyGetter };
